#!/bin/sh

set -ue
PATH=/usr/bin:/bin
export PATH

while read id; do
  printf "output = /dev/null\\nurl = \"$1\"\\n" "$id";
done \
| curl -sLw "%{http_code} %{size_download} %{time_starttransfer} %{time_total} %{url_effective}\\n" -K- \
| awk '
    { for (i = 0; i < 3; i++) {
        v = $(i+2);
        sum[i] += v;
        sumsq[i] += v^2;
        min[i] = (length(min[i]) == 0 || v < min[i]) ? v : min[i];
        max[i] = (length(max[i]) == 0 || v > max[i]) ? v : max[i];
      }
      print $0;
    }
    END {
      printf "                     average  stddev  minimum  maximum\n";
      printf "-------------------  -------  ------  -------  -------\n";
      printf "size (byte)          %7.0f  %6.0f  %7d  %7d\n",     sum[0]/NR, sqrt(sumsq[0]/NR - (sum[0]/NR)^2), min[0], max[0];
      printf "start transfer time  %7.2f  %6.2f  %7.2f  %7.2f\n", sum[1]/NR, sqrt(sumsq[1]/NR - (sum[1]/NR)^2), min[1], max[1];
      printf "total time           %7.2f  %6.2f  %7.2f  %7.2f\n", sum[2]/NR, sqrt(sumsq[2]/NR - (sum[2]/NR)^2), min[2], max[2];
    }'
